"use client";

import { toast } from "sonner";
import { useMutation, useQuery, useQueryClient } from "@tanstack/react-query";

import {
    Form,
    FormControl,
    FormField,
    FormItem,
    FormLabel,
    FormMessage,
} from "@/components/ui/form";

import React, { useEffect, useState } from "react";
import { ErrorResponseProps } from "@/lib/features/admin/account/type";
import { useForm } from "react-hook-form";
import { zodResolver } from "@hookform/resolvers/zod";
import { z } from "zod";
import { Input } from "@/components/ui/input";
import { Button } from "@/components/ui/button";
import { LoaderCircle } from "lucide-react";
import { ResponseProps } from "@/lib/features/login/type";
import { ErrorMessage } from "@/components/ui/error-message";
import Loading from "../../components/loading";
import { Textarea } from "@/components/ui/textarea";
import { geOneQuizQuestion, updateQuizQuestion } from "@/lib/features/admin/quiz/service";
import { UpdateQuizQuestionFormValidation } from "@/lib/features/admin/quiz/schema";

interface Props {
    onCloseModal: () => void;
    refreshNow: () => void;
    dataId: number;
}

export const UpdateQuizQuestionFormDialog = ({ dataId, onCloseModal, refreshNow }: Props) => {

    // states
    const [desc, setDesc] = useState('');
    const [marks, setMarks] = useState('');

    const [status, setStatus] = useState('')
    const [sending, setSending] = useState(false);


    // quiz question details
    const {
        data,
        isLoading,
        error
    } = useQuery({
        queryKey: ["view-quiz-question-details-for-update"],
        queryFn: () => geOneQuizQuestion(dataId),
    });


    // Update states
    useEffect(() => {
        if (data?.data?.details) {
            setDesc(data?.data?.details?.description);
            setMarks(data?.data?.details?.marks);

            setStatus(data?.data?.details?.status);
        }

    }, [data]);



    const queryClient = useQueryClient();

    const mutation = useMutation({
        mutationFn: updateQuizQuestion,
        onSuccess: (data) => {
            queryClient.invalidateQueries({ queryKey: ["updateQuizQuestionInfo"] });

            const response = data as unknown as ResponseProps;

            if (response?.data?.message) {
                toast.success(response?.data?.message);

                // close modal
                onCloseModal();

                //refresh clubs
                refreshNow();

            } else {
                toast.error(response?.data?.error);
            }

            //window.location.reload();
        },
        onError: (error) => {

            const newError = error as unknown as ErrorResponseProps;
            toast.error(newError?.response?.data?.message);

            return false;
            //window.location.reload();
        },
    });

    function onSubmit() {

        if (desc === null || desc === '') {
            toast.error("Question is required");
            return false;
        }

        else if (marks === null || marks === '') {
            toast.error("Marks is required");
            return false;
        }

        else if (status === null || status === '') {
            toast.error("Status is required");
            return false;
        }

        else {

            setSending(true);

            const body = {
                description: desc,
                marks: marks,
                status: status,
                questionId: dataId
            }

            // console.log(JSON.stringify(body));
            // return false;

            mutation.mutate(body);
        }
    }



    // Form setup
    const form = useForm<z.infer<typeof UpdateQuizQuestionFormValidation>>({
        resolver: zodResolver(UpdateQuizQuestionFormValidation),
        defaultValues: {
        },
    });


    if (isLoading) {
        return <Loading />;
    }


    //////////////////////error handling

    //error
    if (error) {
        return <ErrorMessage error={error} fallback="Dashboard error" />
    }



    return (
        <div>
            <div className="text-sm font-medium text-center text-neutral-600 pb-4">
                Update quiz
            </div>

            <Form {...form}>
                <form className="space-y-6">
                    <div className="grid gap-2">

                        <div className="grid grid-cols-1 gap-2">

                            <FormField
                                control={form.control}
                                name="description"
                                render={({ }) => (
                                    <FormItem>
                                        <FormLabel>Question</FormLabel>
                                        <FormControl>
                                            <Textarea value={desc} onChange={(e) => setDesc(e.target.value)} />
                                        </FormControl>
                                        <FormMessage />
                                    </FormItem>
                                )}
                            />

                            <FormField
                                control={form.control}
                                name="marks"
                                render={({ }) => (
                                    <FormItem>
                                        <FormLabel>Marks</FormLabel>
                                        <FormControl>
                                            <Input type="number" value={marks} onChange={(e) => setMarks(e.target.value)} />
                                        </FormControl>
                                        <FormMessage />
                                    </FormItem>
                                )}
                            />


                            <FormField
                                control={form.control}
                                name="status"
                                render={({ }) => (
                                    <FormItem>
                                        <FormLabel>Status</FormLabel>
                                        <select
                                            className="w-full border border-gray-300 rounded p-2"
                                            value={status}
                                            onChange={(e) => setStatus(e.target.value)}
                                        >
                                            <option value=""></option>

                                            <option key="1" value="1">Active</option>
                                            <option key="0" value="0" className="text-red-500">Remove</option>
                                        </select>
                                        <FormMessage />
                                    </FormItem>
                                )}
                            />


                        </div>

                        <Button className="confirm-button mt-4" type="button" onClick={onSubmit}  >
                            {sending ?
                                <LoaderCircle className="animate-spin" />
                                : "UPDATE"
                            }
                        </Button>
                    </div>
                </form>
            </Form>
        </div>
    );

}